# openapi_client.ConfigurationParameterValueChangeActionsApi

All URIs are relative to *http://localhost/rdm/svm-api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**create_configuration_parameter_valuechange_action**](ConfigurationParameterValueChangeActionsApi.md#create_configuration_parameter_valuechange_action) | **POST** /configuration-parameter-value-change-actions | 
[**delete_configuration_parameter_value_change_action**](ConfigurationParameterValueChangeActionsApi.md#delete_configuration_parameter_value_change_action) | **DELETE** /configuration-parameter-value-change-actions/{configuration_parameter_value_change_action_id} | 
[**retriececollectionof_configuration_parameter_value_change_actionobjects**](ConfigurationParameterValueChangeActionsApi.md#retriececollectionof_configuration_parameter_value_change_actionobjects) | **GET** /configuration-parameter-value-change-actions | 
[**retrieve_configuration_parameter_value_change_actioninstance**](ConfigurationParameterValueChangeActionsApi.md#retrieve_configuration_parameter_value_change_actioninstance) | **GET** /configuration-parameter-value-change-actions/{configuration_parameter_value_change_action_id} | 
[**update_configuration_parameter_value_change_action**](ConfigurationParameterValueChangeActionsApi.md#update_configuration_parameter_value_change_action) | **PATCH** /configuration-parameter-value-change-actions/{configuration_parameter_value_change_action_id} | 


# **create_configuration_parameter_valuechange_action**
> CreateConfigurationParameterValuechangeAction201Response create_configuration_parameter_valuechange_action(create_configuration_parameter_valuechange_action_request)



### Example

* Api Key Authentication (ApiKeyAuth):

```python
import openapi_client
from openapi_client.models.create_configuration_parameter_valuechange_action201_response import CreateConfigurationParameterValuechangeAction201Response
from openapi_client.models.create_configuration_parameter_valuechange_action_request import CreateConfigurationParameterValuechangeActionRequest
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost/rdm/svm-api/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "http://localhost/rdm/svm-api/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'

# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.ConfigurationParameterValueChangeActionsApi(api_client)
    create_configuration_parameter_valuechange_action_request = openapi_client.CreateConfigurationParameterValuechangeActionRequest() # CreateConfigurationParameterValuechangeActionRequest | 

    try:
        api_response = api_instance.create_configuration_parameter_valuechange_action(create_configuration_parameter_valuechange_action_request)
        print("The response of ConfigurationParameterValueChangeActionsApi->create_configuration_parameter_valuechange_action:\n")
        pprint(api_response)
    except Exception as e:
        print("Exception when calling ConfigurationParameterValueChangeActionsApi->create_configuration_parameter_valuechange_action: %s\n" % e)
```



### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **create_configuration_parameter_valuechange_action_request** | [**CreateConfigurationParameterValuechangeActionRequest**](CreateConfigurationParameterValuechangeActionRequest.md)|  | 

### Return type

[**CreateConfigurationParameterValuechangeAction201Response**](CreateConfigurationParameterValuechangeAction201Response.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/vnd.api+json
 - **Accept**: application/vnd.api+json

### HTTP response details

| Status code | Description | Response headers |
|-------------|-------------|------------------|
**201** | Payload of the created configuration parameter value change action |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **delete_configuration_parameter_value_change_action**
> DeleteConfigurationAttachmentfromconfigurationattachment0200Response delete_configuration_parameter_value_change_action(configuration_parameter_value_change_action_id)



### Example

* Api Key Authentication (ApiKeyAuth):

```python
import openapi_client
from openapi_client.models.delete_configuration_attachmentfromconfigurationattachment0200_response import DeleteConfigurationAttachmentfromconfigurationattachment0200Response
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost/rdm/svm-api/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "http://localhost/rdm/svm-api/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'

# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.ConfigurationParameterValueChangeActionsApi(api_client)
    configuration_parameter_value_change_action_id = 'configuration_parameter_value_change_action_id_example' # str | 

    try:
        api_response = api_instance.delete_configuration_parameter_value_change_action(configuration_parameter_value_change_action_id)
        print("The response of ConfigurationParameterValueChangeActionsApi->delete_configuration_parameter_value_change_action:\n")
        pprint(api_response)
    except Exception as e:
        print("Exception when calling ConfigurationParameterValueChangeActionsApi->delete_configuration_parameter_value_change_action: %s\n" % e)
```



### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **configuration_parameter_value_change_action_id** | **str**|  | 

### Return type

[**DeleteConfigurationAttachmentfromconfigurationattachment0200Response**](DeleteConfigurationAttachmentfromconfigurationattachment0200Response.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/vnd.api+json

### HTTP response details

| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | Delete an Object |  -  |
**404** |  |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **retriececollectionof_configuration_parameter_value_change_actionobjects**
> RetriececollectionofConfigurationParameterValueChangeActionobjects200Response retriececollectionof_configuration_parameter_value_change_actionobjects(include=include, page_number=page_number, page_size=page_size, sort=sort, filter_id=filter_id, filter_value=filter_value, filter_description=filter_description, filter_date=filter_date, filter_created_at=filter_created_at, filter_updated_at=filter_updated_at)



Retrieve the list of configuration parameter value change actions

### Example

* Api Key Authentication (ApiKeyAuth):

```python
import openapi_client
from openapi_client.models.retriececollectionof_configuration_parameter_value_change_actionobjects200_response import RetriececollectionofConfigurationParameterValueChangeActionobjects200Response
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost/rdm/svm-api/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "http://localhost/rdm/svm-api/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'

# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.ConfigurationParameterValueChangeActionsApi(api_client)
    include = '' # str | Relationships to include. (optional) (default to '')
    page_number = 1 # int | Page number to query (optional) (default to 1)
    page_size = 30 # int | Max number of items (optional) (default to 30)
    sort = '' # str | Sort order (optional) (default to '')
    filter_id = 'filter_id_example' # str |  (optional)
    filter_value = 'filter_value_example' # str |  (optional)
    filter_description = 'filter_description_example' # str |  (optional)
    filter_date = '2013-10-20T19:20:30+01:00' # datetime |  (optional)
    filter_created_at = '2013-10-20T19:20:30+01:00' # datetime |  (optional)
    filter_updated_at = '2013-10-20T19:20:30+01:00' # datetime |  (optional)

    try:
        api_response = api_instance.retriececollectionof_configuration_parameter_value_change_actionobjects(include=include, page_number=page_number, page_size=page_size, sort=sort, filter_id=filter_id, filter_value=filter_value, filter_description=filter_description, filter_date=filter_date, filter_created_at=filter_created_at, filter_updated_at=filter_updated_at)
        print("The response of ConfigurationParameterValueChangeActionsApi->retriececollectionof_configuration_parameter_value_change_actionobjects:\n")
        pprint(api_response)
    except Exception as e:
        print("Exception when calling ConfigurationParameterValueChangeActionsApi->retriececollectionof_configuration_parameter_value_change_actionobjects: %s\n" % e)
```



### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **include** | **str**| Relationships to include. | [optional] [default to &#39;&#39;]
 **page_number** | **int**| Page number to query | [optional] [default to 1]
 **page_size** | **int**| Max number of items | [optional] [default to 30]
 **sort** | **str**| Sort order | [optional] [default to &#39;&#39;]
 **filter_id** | **str**|  | [optional] 
 **filter_value** | **str**|  | [optional] 
 **filter_description** | **str**|  | [optional] 
 **filter_date** | **datetime**|  | [optional] 
 **filter_created_at** | **datetime**|  | [optional] 
 **filter_updated_at** | **datetime**|  | [optional] 

### Return type

[**RetriececollectionofConfigurationParameterValueChangeActionobjects200Response**](RetriececollectionofConfigurationParameterValueChangeActionobjects200Response.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/vnd.api+json

### HTTP response details

| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | List of configuration parameter value change actions |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **retrieve_configuration_parameter_value_change_actioninstance**
> CreateConfigurationParameterValuechangeAction201Response retrieve_configuration_parameter_value_change_actioninstance(configuration_parameter_value_change_action_id, include=include)



Retrieve a single configuration parameter value change action

### Example

* Api Key Authentication (ApiKeyAuth):

```python
import openapi_client
from openapi_client.models.create_configuration_parameter_valuechange_action201_response import CreateConfigurationParameterValuechangeAction201Response
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost/rdm/svm-api/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "http://localhost/rdm/svm-api/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'

# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.ConfigurationParameterValueChangeActionsApi(api_client)
    configuration_parameter_value_change_action_id = 'configuration_parameter_value_change_action_id_example' # str | 
    include = '' # str | Relationships to include. (optional) (default to '')

    try:
        api_response = api_instance.retrieve_configuration_parameter_value_change_actioninstance(configuration_parameter_value_change_action_id, include=include)
        print("The response of ConfigurationParameterValueChangeActionsApi->retrieve_configuration_parameter_value_change_actioninstance:\n")
        pprint(api_response)
    except Exception as e:
        print("Exception when calling ConfigurationParameterValueChangeActionsApi->retrieve_configuration_parameter_value_change_actioninstance: %s\n" % e)
```



### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **configuration_parameter_value_change_action_id** | **str**|  | 
 **include** | **str**| Relationships to include. | [optional] [default to &#39;&#39;]

### Return type

[**CreateConfigurationParameterValuechangeAction201Response**](CreateConfigurationParameterValuechangeAction201Response.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/vnd.api+json

### HTTP response details

| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | Instance of a configuration parameter value change action |  -  |
**404** |  |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_configuration_parameter_value_change_action**
> CreateConfigurationParameterValuechangeAction201Response update_configuration_parameter_value_change_action(configuration_parameter_value_change_action_id, update_configuration_parameter_value_change_action_request)



Update ConfigurationParameterValueChangeAction attributes

### Example

* Api Key Authentication (ApiKeyAuth):

```python
import openapi_client
from openapi_client.models.create_configuration_parameter_valuechange_action201_response import CreateConfigurationParameterValuechangeAction201Response
from openapi_client.models.update_configuration_parameter_value_change_action_request import UpdateConfigurationParameterValueChangeActionRequest
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost/rdm/svm-api/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "http://localhost/rdm/svm-api/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'

# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.ConfigurationParameterValueChangeActionsApi(api_client)
    configuration_parameter_value_change_action_id = 'configuration_parameter_value_change_action_id_example' # str | 
    update_configuration_parameter_value_change_action_request = openapi_client.UpdateConfigurationParameterValueChangeActionRequest() # UpdateConfigurationParameterValueChangeActionRequest | ConfigurationParameterValueChangeAction attributes

    try:
        api_response = api_instance.update_configuration_parameter_value_change_action(configuration_parameter_value_change_action_id, update_configuration_parameter_value_change_action_request)
        print("The response of ConfigurationParameterValueChangeActionsApi->update_configuration_parameter_value_change_action:\n")
        pprint(api_response)
    except Exception as e:
        print("Exception when calling ConfigurationParameterValueChangeActionsApi->update_configuration_parameter_value_change_action: %s\n" % e)
```



### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **configuration_parameter_value_change_action_id** | **str**|  | 
 **update_configuration_parameter_value_change_action_request** | [**UpdateConfigurationParameterValueChangeActionRequest**](UpdateConfigurationParameterValueChangeActionRequest.md)| ConfigurationParameterValueChangeAction attributes | 

### Return type

[**CreateConfigurationParameterValuechangeAction201Response**](CreateConfigurationParameterValuechangeAction201Response.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/vnd.api+json
 - **Accept**: application/vnd.api+json

### HTTP response details

| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | Payload of the updated configuration parameter value change action |  -  |
**404** |  |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

