# openapi_client.DeviceParameterValueChangeActionsApi

All URIs are relative to *http://localhost/rdm/svm-api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**create_device_parameter_valuechange_action**](DeviceParameterValueChangeActionsApi.md#create_device_parameter_valuechange_action) | **POST** /device-parameter-value-change-actions | 
[**delete_device_parameter_value_change_action**](DeviceParameterValueChangeActionsApi.md#delete_device_parameter_value_change_action) | **DELETE** /device-parameter-value-change-actions/{device_parameter_value_change_action_id} | 
[**retriececollectionof_device_parameter_value_change_actionobjects**](DeviceParameterValueChangeActionsApi.md#retriececollectionof_device_parameter_value_change_actionobjects) | **GET** /device-parameter-value-change-actions | 
[**retrieve_device_parameter_value_change_actioninstance**](DeviceParameterValueChangeActionsApi.md#retrieve_device_parameter_value_change_actioninstance) | **GET** /device-parameter-value-change-actions/{device_parameter_value_change_action_id} | 
[**update_device_parameter_value_change_action**](DeviceParameterValueChangeActionsApi.md#update_device_parameter_value_change_action) | **PATCH** /device-parameter-value-change-actions/{device_parameter_value_change_action_id} | 


# **create_device_parameter_valuechange_action**
> CreateDeviceParameterValuechangeAction201Response create_device_parameter_valuechange_action(create_device_parameter_valuechange_action_request)



### Example

* Api Key Authentication (ApiKeyAuth):

```python
import openapi_client
from openapi_client.models.create_device_parameter_valuechange_action201_response import CreateDeviceParameterValuechangeAction201Response
from openapi_client.models.create_device_parameter_valuechange_action_request import CreateDeviceParameterValuechangeActionRequest
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost/rdm/svm-api/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "http://localhost/rdm/svm-api/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'

# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.DeviceParameterValueChangeActionsApi(api_client)
    create_device_parameter_valuechange_action_request = openapi_client.CreateDeviceParameterValuechangeActionRequest() # CreateDeviceParameterValuechangeActionRequest | 

    try:
        api_response = api_instance.create_device_parameter_valuechange_action(create_device_parameter_valuechange_action_request)
        print("The response of DeviceParameterValueChangeActionsApi->create_device_parameter_valuechange_action:\n")
        pprint(api_response)
    except Exception as e:
        print("Exception when calling DeviceParameterValueChangeActionsApi->create_device_parameter_valuechange_action: %s\n" % e)
```



### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **create_device_parameter_valuechange_action_request** | [**CreateDeviceParameterValuechangeActionRequest**](CreateDeviceParameterValuechangeActionRequest.md)|  | 

### Return type

[**CreateDeviceParameterValuechangeAction201Response**](CreateDeviceParameterValuechangeAction201Response.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/vnd.api+json
 - **Accept**: application/vnd.api+json

### HTTP response details

| Status code | Description | Response headers |
|-------------|-------------|------------------|
**201** | Payload of the created device parameter value change action |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **delete_device_parameter_value_change_action**
> DeleteConfigurationAttachmentfromconfigurationattachment0200Response delete_device_parameter_value_change_action(device_parameter_value_change_action_id)



### Example

* Api Key Authentication (ApiKeyAuth):

```python
import openapi_client
from openapi_client.models.delete_configuration_attachmentfromconfigurationattachment0200_response import DeleteConfigurationAttachmentfromconfigurationattachment0200Response
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost/rdm/svm-api/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "http://localhost/rdm/svm-api/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'

# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.DeviceParameterValueChangeActionsApi(api_client)
    device_parameter_value_change_action_id = 'device_parameter_value_change_action_id_example' # str | 

    try:
        api_response = api_instance.delete_device_parameter_value_change_action(device_parameter_value_change_action_id)
        print("The response of DeviceParameterValueChangeActionsApi->delete_device_parameter_value_change_action:\n")
        pprint(api_response)
    except Exception as e:
        print("Exception when calling DeviceParameterValueChangeActionsApi->delete_device_parameter_value_change_action: %s\n" % e)
```



### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **device_parameter_value_change_action_id** | **str**|  | 

### Return type

[**DeleteConfigurationAttachmentfromconfigurationattachment0200Response**](DeleteConfigurationAttachmentfromconfigurationattachment0200Response.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/vnd.api+json

### HTTP response details

| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | Delete an Object |  -  |
**404** |  |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **retriececollectionof_device_parameter_value_change_actionobjects**
> RetriececollectionofDeviceParameterValueChangeActionobjects200Response retriececollectionof_device_parameter_value_change_actionobjects(include=include, page_number=page_number, page_size=page_size, sort=sort, filter_id=filter_id, filter_value=filter_value, filter_description=filter_description, filter_date=filter_date, filter_created_at=filter_created_at, filter_updated_at=filter_updated_at)



Retrieve the list of device parameter value change actions

### Example

* Api Key Authentication (ApiKeyAuth):

```python
import openapi_client
from openapi_client.models.retriececollectionof_device_parameter_value_change_actionobjects200_response import RetriececollectionofDeviceParameterValueChangeActionobjects200Response
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost/rdm/svm-api/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "http://localhost/rdm/svm-api/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'

# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.DeviceParameterValueChangeActionsApi(api_client)
    include = '' # str | Relationships to include. (optional) (default to '')
    page_number = 1 # int | Page number to query (optional) (default to 1)
    page_size = 30 # int | Max number of items (optional) (default to 30)
    sort = '' # str | Sort order (optional) (default to '')
    filter_id = 'filter_id_example' # str |  (optional)
    filter_value = 'filter_value_example' # str |  (optional)
    filter_description = 'filter_description_example' # str |  (optional)
    filter_date = '2013-10-20T19:20:30+01:00' # datetime |  (optional)
    filter_created_at = '2013-10-20T19:20:30+01:00' # datetime |  (optional)
    filter_updated_at = '2013-10-20T19:20:30+01:00' # datetime |  (optional)

    try:
        api_response = api_instance.retriececollectionof_device_parameter_value_change_actionobjects(include=include, page_number=page_number, page_size=page_size, sort=sort, filter_id=filter_id, filter_value=filter_value, filter_description=filter_description, filter_date=filter_date, filter_created_at=filter_created_at, filter_updated_at=filter_updated_at)
        print("The response of DeviceParameterValueChangeActionsApi->retriececollectionof_device_parameter_value_change_actionobjects:\n")
        pprint(api_response)
    except Exception as e:
        print("Exception when calling DeviceParameterValueChangeActionsApi->retriececollectionof_device_parameter_value_change_actionobjects: %s\n" % e)
```



### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **include** | **str**| Relationships to include. | [optional] [default to &#39;&#39;]
 **page_number** | **int**| Page number to query | [optional] [default to 1]
 **page_size** | **int**| Max number of items | [optional] [default to 30]
 **sort** | **str**| Sort order | [optional] [default to &#39;&#39;]
 **filter_id** | **str**|  | [optional] 
 **filter_value** | **str**|  | [optional] 
 **filter_description** | **str**|  | [optional] 
 **filter_date** | **datetime**|  | [optional] 
 **filter_created_at** | **datetime**|  | [optional] 
 **filter_updated_at** | **datetime**|  | [optional] 

### Return type

[**RetriececollectionofDeviceParameterValueChangeActionobjects200Response**](RetriececollectionofDeviceParameterValueChangeActionobjects200Response.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/vnd.api+json

### HTTP response details

| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | List of device parameter value change actions |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **retrieve_device_parameter_value_change_actioninstance**
> CreateDeviceParameterValuechangeAction201Response retrieve_device_parameter_value_change_actioninstance(device_parameter_value_change_action_id, include=include)



Retrieve a single device parameter value change action

### Example

* Api Key Authentication (ApiKeyAuth):

```python
import openapi_client
from openapi_client.models.create_device_parameter_valuechange_action201_response import CreateDeviceParameterValuechangeAction201Response
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost/rdm/svm-api/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "http://localhost/rdm/svm-api/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'

# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.DeviceParameterValueChangeActionsApi(api_client)
    device_parameter_value_change_action_id = 'device_parameter_value_change_action_id_example' # str | 
    include = '' # str | Relationships to include. (optional) (default to '')

    try:
        api_response = api_instance.retrieve_device_parameter_value_change_actioninstance(device_parameter_value_change_action_id, include=include)
        print("The response of DeviceParameterValueChangeActionsApi->retrieve_device_parameter_value_change_actioninstance:\n")
        pprint(api_response)
    except Exception as e:
        print("Exception when calling DeviceParameterValueChangeActionsApi->retrieve_device_parameter_value_change_actioninstance: %s\n" % e)
```



### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **device_parameter_value_change_action_id** | **str**|  | 
 **include** | **str**| Relationships to include. | [optional] [default to &#39;&#39;]

### Return type

[**CreateDeviceParameterValuechangeAction201Response**](CreateDeviceParameterValuechangeAction201Response.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/vnd.api+json

### HTTP response details

| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | Instance of the device parameter value change action |  -  |
**404** |  |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_device_parameter_value_change_action**
> CreateDeviceParameterValuechangeAction201Response update_device_parameter_value_change_action(device_parameter_value_change_action_id, update_device_parameter_value_change_action_request)



Update DeviceParameterValueChangeAction attributes

### Example

* Api Key Authentication (ApiKeyAuth):

```python
import openapi_client
from openapi_client.models.create_device_parameter_valuechange_action201_response import CreateDeviceParameterValuechangeAction201Response
from openapi_client.models.update_device_parameter_value_change_action_request import UpdateDeviceParameterValueChangeActionRequest
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost/rdm/svm-api/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "http://localhost/rdm/svm-api/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'

# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.DeviceParameterValueChangeActionsApi(api_client)
    device_parameter_value_change_action_id = 'device_parameter_value_change_action_id_example' # str | 
    update_device_parameter_value_change_action_request = openapi_client.UpdateDeviceParameterValueChangeActionRequest() # UpdateDeviceParameterValueChangeActionRequest | DeviceParameterValueChangeAction attributes

    try:
        api_response = api_instance.update_device_parameter_value_change_action(device_parameter_value_change_action_id, update_device_parameter_value_change_action_request)
        print("The response of DeviceParameterValueChangeActionsApi->update_device_parameter_value_change_action:\n")
        pprint(api_response)
    except Exception as e:
        print("Exception when calling DeviceParameterValueChangeActionsApi->update_device_parameter_value_change_action: %s\n" % e)
```



### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **device_parameter_value_change_action_id** | **str**|  | 
 **update_device_parameter_value_change_action_request** | [**UpdateDeviceParameterValueChangeActionRequest**](UpdateDeviceParameterValueChangeActionRequest.md)| DeviceParameterValueChangeAction attributes | 

### Return type

[**CreateDeviceParameterValuechangeAction201Response**](CreateDeviceParameterValuechangeAction201Response.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/vnd.api+json
 - **Accept**: application/vnd.api+json

### HTTP response details

| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | Payload of the updated device parameter value change action |  -  |
**404** |  |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

