# openapi_client.PlatformSoftwareUpdateActionAttachmentsApi

All URIs are relative to *http://localhost/rdm/svm-api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**platform_software_update_action_attachments_get**](PlatformSoftwareUpdateActionAttachmentsApi.md#platform_software_update_action_attachments_get) | **GET** /platform-software-update-action-attachments | 
[**platform_software_update_action_attachments_platform_software_update_action_attachment_id_delete**](PlatformSoftwareUpdateActionAttachmentsApi.md#platform_software_update_action_attachments_platform_software_update_action_attachment_id_delete) | **DELETE** /platform-software-update-action-attachments/{platform_software_update_action_attachment_id} | 
[**platform_software_update_action_attachments_platform_software_update_action_attachment_id_get**](PlatformSoftwareUpdateActionAttachmentsApi.md#platform_software_update_action_attachments_platform_software_update_action_attachment_id_get) | **GET** /platform-software-update-action-attachments/{platform_software_update_action_attachment_id} | 
[**platform_software_update_action_attachments_platform_software_update_action_attachment_id_patch**](PlatformSoftwareUpdateActionAttachmentsApi.md#platform_software_update_action_attachments_platform_software_update_action_attachment_id_patch) | **PATCH** /platform-software-update-action-attachments/{platform_software_update_action_attachment_id} | 
[**platform_software_update_action_attachments_post**](PlatformSoftwareUpdateActionAttachmentsApi.md#platform_software_update_action_attachments_post) | **POST** /platform-software-update-action-attachments | 


# **platform_software_update_action_attachments_get**
> PlatformSoftwareUpdateActionAttachmentsGet200Response platform_software_update_action_attachments_get(include=include, page_number=page_number, page_size=page_size, sort=sort, filter_id=filter_id, filter=filter)



### Example

* Api Key Authentication (ApiKeyAuth):

```python
import openapi_client
from openapi_client.models.platform_software_update_action_attachments_get200_response import PlatformSoftwareUpdateActionAttachmentsGet200Response
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost/rdm/svm-api/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "http://localhost/rdm/svm-api/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'

# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.PlatformSoftwareUpdateActionAttachmentsApi(api_client)
    include = '' # str | Relationships to include. (optional) (default to '')
    page_number = 1 # int | Page number to query (optional) (default to 1)
    page_size = 30 # int | Max number of items (optional) (default to 30)
    sort = '' # str | Sort order (optional) (default to '')
    filter_id = 'filter_id_example' # str |  (optional)
    filter = 'filter_example' # str | Custom filter (optional)

    try:
        api_response = api_instance.platform_software_update_action_attachments_get(include=include, page_number=page_number, page_size=page_size, sort=sort, filter_id=filter_id, filter=filter)
        print("The response of PlatformSoftwareUpdateActionAttachmentsApi->platform_software_update_action_attachments_get:\n")
        pprint(api_response)
    except Exception as e:
        print("Exception when calling PlatformSoftwareUpdateActionAttachmentsApi->platform_software_update_action_attachments_get: %s\n" % e)
```



### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **include** | **str**| Relationships to include. | [optional] [default to &#39;&#39;]
 **page_number** | **int**| Page number to query | [optional] [default to 1]
 **page_size** | **int**| Max number of items | [optional] [default to 30]
 **sort** | **str**| Sort order | [optional] [default to &#39;&#39;]
 **filter_id** | **str**|  | [optional] 
 **filter** | **str**| Custom filter | [optional] 

### Return type

[**PlatformSoftwareUpdateActionAttachmentsGet200Response**](PlatformSoftwareUpdateActionAttachmentsGet200Response.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/vnd.api+json

### HTTP response details

| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | List of platform software update action attachments |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platform_software_update_action_attachments_platform_software_update_action_attachment_id_delete**
> DeleteConfigurationAttachmentfromconfigurationattachment0200Response platform_software_update_action_attachments_platform_software_update_action_attachment_id_delete(platform_software_update_action_attachment_id)



### Example

* Api Key Authentication (ApiKeyAuth):

```python
import openapi_client
from openapi_client.models.delete_configuration_attachmentfromconfigurationattachment0200_response import DeleteConfigurationAttachmentfromconfigurationattachment0200Response
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost/rdm/svm-api/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "http://localhost/rdm/svm-api/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'

# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.PlatformSoftwareUpdateActionAttachmentsApi(api_client)
    platform_software_update_action_attachment_id = 'platform_software_update_action_attachment_id_example' # str | 

    try:
        api_response = api_instance.platform_software_update_action_attachments_platform_software_update_action_attachment_id_delete(platform_software_update_action_attachment_id)
        print("The response of PlatformSoftwareUpdateActionAttachmentsApi->platform_software_update_action_attachments_platform_software_update_action_attachment_id_delete:\n")
        pprint(api_response)
    except Exception as e:
        print("Exception when calling PlatformSoftwareUpdateActionAttachmentsApi->platform_software_update_action_attachments_platform_software_update_action_attachment_id_delete: %s\n" % e)
```



### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **platform_software_update_action_attachment_id** | **str**|  | 

### Return type

[**DeleteConfigurationAttachmentfromconfigurationattachment0200Response**](DeleteConfigurationAttachmentfromconfigurationattachment0200Response.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/vnd.api+json

### HTTP response details

| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | Delete an Object |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platform_software_update_action_attachments_platform_software_update_action_attachment_id_get**
> PlatformSoftwareUpdateActionAttachmentsPost201Response platform_software_update_action_attachments_platform_software_update_action_attachment_id_get(platform_software_update_action_attachment_id, include=include)



### Example

* Api Key Authentication (ApiKeyAuth):

```python
import openapi_client
from openapi_client.models.platform_software_update_action_attachments_post201_response import PlatformSoftwareUpdateActionAttachmentsPost201Response
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost/rdm/svm-api/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "http://localhost/rdm/svm-api/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'

# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.PlatformSoftwareUpdateActionAttachmentsApi(api_client)
    platform_software_update_action_attachment_id = 'platform_software_update_action_attachment_id_example' # str | 
    include = '' # str | Relationships to include. (optional) (default to '')

    try:
        api_response = api_instance.platform_software_update_action_attachments_platform_software_update_action_attachment_id_get(platform_software_update_action_attachment_id, include=include)
        print("The response of PlatformSoftwareUpdateActionAttachmentsApi->platform_software_update_action_attachments_platform_software_update_action_attachment_id_get:\n")
        pprint(api_response)
    except Exception as e:
        print("Exception when calling PlatformSoftwareUpdateActionAttachmentsApi->platform_software_update_action_attachments_platform_software_update_action_attachment_id_get: %s\n" % e)
```



### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **platform_software_update_action_attachment_id** | **str**|  | 
 **include** | **str**| Relationships to include. | [optional] [default to &#39;&#39;]

### Return type

[**PlatformSoftwareUpdateActionAttachmentsPost201Response**](PlatformSoftwareUpdateActionAttachmentsPost201Response.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/vnd.api+json

### HTTP response details

| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | Instance of a platform software update action attachment |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platform_software_update_action_attachments_platform_software_update_action_attachment_id_patch**
> PlatformSoftwareUpdateActionAttachmentsPost201Response platform_software_update_action_attachments_platform_software_update_action_attachment_id_patch(platform_software_update_action_attachment_id, platform_software_update_action_attachments_platform_software_update_action_attachment_id_patch_request)



### Example

* Api Key Authentication (ApiKeyAuth):

```python
import openapi_client
from openapi_client.models.platform_software_update_action_attachments_platform_software_update_action_attachment_id_patch_request import PlatformSoftwareUpdateActionAttachmentsPlatformSoftwareUpdateActionAttachmentIdPatchRequest
from openapi_client.models.platform_software_update_action_attachments_post201_response import PlatformSoftwareUpdateActionAttachmentsPost201Response
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost/rdm/svm-api/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "http://localhost/rdm/svm-api/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'

# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.PlatformSoftwareUpdateActionAttachmentsApi(api_client)
    platform_software_update_action_attachment_id = 'platform_software_update_action_attachment_id_example' # str | 
    platform_software_update_action_attachments_platform_software_update_action_attachment_id_patch_request = openapi_client.PlatformSoftwareUpdateActionAttachmentsPlatformSoftwareUpdateActionAttachmentIdPatchRequest() # PlatformSoftwareUpdateActionAttachmentsPlatformSoftwareUpdateActionAttachmentIdPatchRequest | Platform software update action attachment attributes

    try:
        api_response = api_instance.platform_software_update_action_attachments_platform_software_update_action_attachment_id_patch(platform_software_update_action_attachment_id, platform_software_update_action_attachments_platform_software_update_action_attachment_id_patch_request)
        print("The response of PlatformSoftwareUpdateActionAttachmentsApi->platform_software_update_action_attachments_platform_software_update_action_attachment_id_patch:\n")
        pprint(api_response)
    except Exception as e:
        print("Exception when calling PlatformSoftwareUpdateActionAttachmentsApi->platform_software_update_action_attachments_platform_software_update_action_attachment_id_patch: %s\n" % e)
```



### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **platform_software_update_action_attachment_id** | **str**|  | 
 **platform_software_update_action_attachments_platform_software_update_action_attachment_id_patch_request** | [**PlatformSoftwareUpdateActionAttachmentsPlatformSoftwareUpdateActionAttachmentIdPatchRequest**](PlatformSoftwareUpdateActionAttachmentsPlatformSoftwareUpdateActionAttachmentIdPatchRequest.md)| Platform software update action attachment attributes | 

### Return type

[**PlatformSoftwareUpdateActionAttachmentsPost201Response**](PlatformSoftwareUpdateActionAttachmentsPost201Response.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/vnd.api+json
 - **Accept**: application/vnd.api+json

### HTTP response details

| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | Payload of the updated platform software update action attachment |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platform_software_update_action_attachments_post**
> PlatformSoftwareUpdateActionAttachmentsPost201Response platform_software_update_action_attachments_post(platform_software_update_action_attachments_post_request)



### Example

* Api Key Authentication (ApiKeyAuth):

```python
import openapi_client
from openapi_client.models.platform_software_update_action_attachments_post201_response import PlatformSoftwareUpdateActionAttachmentsPost201Response
from openapi_client.models.platform_software_update_action_attachments_post_request import PlatformSoftwareUpdateActionAttachmentsPostRequest
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost/rdm/svm-api/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "http://localhost/rdm/svm-api/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'

# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.PlatformSoftwareUpdateActionAttachmentsApi(api_client)
    platform_software_update_action_attachments_post_request = openapi_client.PlatformSoftwareUpdateActionAttachmentsPostRequest() # PlatformSoftwareUpdateActionAttachmentsPostRequest | 

    try:
        api_response = api_instance.platform_software_update_action_attachments_post(platform_software_update_action_attachments_post_request)
        print("The response of PlatformSoftwareUpdateActionAttachmentsApi->platform_software_update_action_attachments_post:\n")
        pprint(api_response)
    except Exception as e:
        print("Exception when calling PlatformSoftwareUpdateActionAttachmentsApi->platform_software_update_action_attachments_post: %s\n" % e)
```



### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **platform_software_update_action_attachments_post_request** | [**PlatformSoftwareUpdateActionAttachmentsPostRequest**](PlatformSoftwareUpdateActionAttachmentsPostRequest.md)|  | 

### Return type

[**PlatformSoftwareUpdateActionAttachmentsPost201Response**](PlatformSoftwareUpdateActionAttachmentsPost201Response.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/vnd.api+json
 - **Accept**: application/vnd.api+json

### HTTP response details

| Status code | Description | Response headers |
|-------------|-------------|------------------|
**201** | Payload of the created platform software update action attachment |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

