# openapi_client.StaticLocationActionsApi

All URIs are relative to *http://localhost/rdm/svm-api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**static_location_actions_get**](StaticLocationActionsApi.md#static_location_actions_get) | **GET** /static-location-actions | 
[**static_location_actions_post**](StaticLocationActionsApi.md#static_location_actions_post) | **POST** /static-location-actions | 
[**static_location_actions_static_location_action_id_delete**](StaticLocationActionsApi.md#static_location_actions_static_location_action_id_delete) | **DELETE** /static-location-actions/{static_location_action_id} | 
[**static_location_actions_static_location_action_id_get**](StaticLocationActionsApi.md#static_location_actions_static_location_action_id_get) | **GET** /static-location-actions/{static_location_action_id} | 
[**static_location_actions_static_location_action_id_patch**](StaticLocationActionsApi.md#static_location_actions_static_location_action_id_patch) | **PATCH** /static-location-actions/{static_location_action_id} | 


# **static_location_actions_get**
> StaticLocationActionsGet200Response static_location_actions_get(include=include, page_number=page_number, page_size=page_size, sort=sort, filter_id=filter_id, filter_begin_date=filter_begin_date, filter_end_date=filter_end_date, filter_begin_description=filter_begin_description, filter_end_description=filter_end_description, filter_label=filter_label, filter_x=filter_x, filter_y=filter_y, filter_z=filter_z, filter_epsg_code=filter_epsg_code, filter_elevation_datum_name=filter_elevation_datum_name, filter_elevation_datum_uri=filter_elevation_datum_uri, filter_configuration_id=filter_configuration_id, filter=filter)



Get the list of static location actions.

### Example

* Api Key Authentication (ApiKeyAuth):

```python
import openapi_client
from openapi_client.models.static_location_actions_get200_response import StaticLocationActionsGet200Response
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost/rdm/svm-api/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "http://localhost/rdm/svm-api/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'

# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.StaticLocationActionsApi(api_client)
    include = '' # str | Relationships to include. (optional) (default to '')
    page_number = 1 # int | Page number to query (optional) (default to 1)
    page_size = 30 # int | Max number of items (optional) (default to 30)
    sort = '' # str | Sort order (optional) (default to '')
    filter_id = 'filter_id_example' # str |  (optional)
    filter_begin_date = '2013-10-20T19:20:30+01:00' # datetime |  (optional)
    filter_end_date = '2013-10-20T19:20:30+01:00' # datetime |  (optional)
    filter_begin_description = 'filter_begin_description_example' # str |  (optional)
    filter_end_description = 'filter_end_description_example' # str |  (optional)
    filter_label = 'filter_label_example' # str |  (optional)
    filter_x = 3.4 # float |  (optional)
    filter_y = 3.4 # float |  (optional)
    filter_z = 3.4 # float |  (optional)
    filter_epsg_code = 'filter_epsg_code_example' # str |  (optional)
    filter_elevation_datum_name = 'filter_elevation_datum_name_example' # str |  (optional)
    filter_elevation_datum_uri = 'filter_elevation_datum_uri_example' # str |  (optional)
    filter_configuration_id = 'filter_configuration_id_example' # str |  (optional)
    filter = 'filter_example' # str | Custom filter (optional)

    try:
        api_response = api_instance.static_location_actions_get(include=include, page_number=page_number, page_size=page_size, sort=sort, filter_id=filter_id, filter_begin_date=filter_begin_date, filter_end_date=filter_end_date, filter_begin_description=filter_begin_description, filter_end_description=filter_end_description, filter_label=filter_label, filter_x=filter_x, filter_y=filter_y, filter_z=filter_z, filter_epsg_code=filter_epsg_code, filter_elevation_datum_name=filter_elevation_datum_name, filter_elevation_datum_uri=filter_elevation_datum_uri, filter_configuration_id=filter_configuration_id, filter=filter)
        print("The response of StaticLocationActionsApi->static_location_actions_get:\n")
        pprint(api_response)
    except Exception as e:
        print("Exception when calling StaticLocationActionsApi->static_location_actions_get: %s\n" % e)
```



### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **include** | **str**| Relationships to include. | [optional] [default to &#39;&#39;]
 **page_number** | **int**| Page number to query | [optional] [default to 1]
 **page_size** | **int**| Max number of items | [optional] [default to 30]
 **sort** | **str**| Sort order | [optional] [default to &#39;&#39;]
 **filter_id** | **str**|  | [optional] 
 **filter_begin_date** | **datetime**|  | [optional] 
 **filter_end_date** | **datetime**|  | [optional] 
 **filter_begin_description** | **str**|  | [optional] 
 **filter_end_description** | **str**|  | [optional] 
 **filter_label** | **str**|  | [optional] 
 **filter_x** | **float**|  | [optional] 
 **filter_y** | **float**|  | [optional] 
 **filter_z** | **float**|  | [optional] 
 **filter_epsg_code** | **str**|  | [optional] 
 **filter_elevation_datum_name** | **str**|  | [optional] 
 **filter_elevation_datum_uri** | **str**|  | [optional] 
 **filter_configuration_id** | **str**|  | [optional] 
 **filter** | **str**| Custom filter | [optional] 

### Return type

[**StaticLocationActionsGet200Response**](StaticLocationActionsGet200Response.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/vnd.api+json

### HTTP response details

| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | List of static locations |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **static_location_actions_post**
> StaticLocationActionsPost201Response static_location_actions_post(static_location_actions_post_request)



### Example

* Api Key Authentication (ApiKeyAuth):

```python
import openapi_client
from openapi_client.models.static_location_actions_post201_response import StaticLocationActionsPost201Response
from openapi_client.models.static_location_actions_post_request import StaticLocationActionsPostRequest
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost/rdm/svm-api/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "http://localhost/rdm/svm-api/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'

# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.StaticLocationActionsApi(api_client)
    static_location_actions_post_request = openapi_client.StaticLocationActionsPostRequest() # StaticLocationActionsPostRequest | 

    try:
        api_response = api_instance.static_location_actions_post(static_location_actions_post_request)
        print("The response of StaticLocationActionsApi->static_location_actions_post:\n")
        pprint(api_response)
    except Exception as e:
        print("Exception when calling StaticLocationActionsApi->static_location_actions_post: %s\n" % e)
```



### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **static_location_actions_post_request** | [**StaticLocationActionsPostRequest**](StaticLocationActionsPostRequest.md)|  | 

### Return type

[**StaticLocationActionsPost201Response**](StaticLocationActionsPost201Response.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/vnd.api+json
 - **Accept**: application/vnd.api+json

### HTTP response details

| Status code | Description | Response headers |
|-------------|-------------|------------------|
**201** | Payload of the created static location |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **static_location_actions_static_location_action_id_delete**
> DeleteConfigurationAttachmentfromconfigurationattachment0200Response static_location_actions_static_location_action_id_delete(static_location_action_id)



### Example

* Api Key Authentication (ApiKeyAuth):

```python
import openapi_client
from openapi_client.models.delete_configuration_attachmentfromconfigurationattachment0200_response import DeleteConfigurationAttachmentfromconfigurationattachment0200Response
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost/rdm/svm-api/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "http://localhost/rdm/svm-api/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'

# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.StaticLocationActionsApi(api_client)
    static_location_action_id = 'static_location_action_id_example' # str | 

    try:
        api_response = api_instance.static_location_actions_static_location_action_id_delete(static_location_action_id)
        print("The response of StaticLocationActionsApi->static_location_actions_static_location_action_id_delete:\n")
        pprint(api_response)
    except Exception as e:
        print("Exception when calling StaticLocationActionsApi->static_location_actions_static_location_action_id_delete: %s\n" % e)
```



### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **static_location_action_id** | **str**|  | 

### Return type

[**DeleteConfigurationAttachmentfromconfigurationattachment0200Response**](DeleteConfigurationAttachmentfromconfigurationattachment0200Response.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/vnd.api+json

### HTTP response details

| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | Delete an Object |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **static_location_actions_static_location_action_id_get**
> StaticLocationActionsPost201Response static_location_actions_static_location_action_id_get(static_location_action_id, include=include)



### Example

* Api Key Authentication (ApiKeyAuth):

```python
import openapi_client
from openapi_client.models.static_location_actions_post201_response import StaticLocationActionsPost201Response
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost/rdm/svm-api/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "http://localhost/rdm/svm-api/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'

# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.StaticLocationActionsApi(api_client)
    static_location_action_id = 'static_location_action_id_example' # str | 
    include = '' # str | Relationships to include. (optional) (default to '')

    try:
        api_response = api_instance.static_location_actions_static_location_action_id_get(static_location_action_id, include=include)
        print("The response of StaticLocationActionsApi->static_location_actions_static_location_action_id_get:\n")
        pprint(api_response)
    except Exception as e:
        print("Exception when calling StaticLocationActionsApi->static_location_actions_static_location_action_id_get: %s\n" % e)
```



### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **static_location_action_id** | **str**|  | 
 **include** | **str**| Relationships to include. | [optional] [default to &#39;&#39;]

### Return type

[**StaticLocationActionsPost201Response**](StaticLocationActionsPost201Response.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/vnd.api+json

### HTTP response details

| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | Instance of a static location |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **static_location_actions_static_location_action_id_patch**
> StaticLocationActionsPost201Response static_location_actions_static_location_action_id_patch(static_location_action_id, static_location_actions_static_location_action_id_patch_request)



### Example

* Api Key Authentication (ApiKeyAuth):

```python
import openapi_client
from openapi_client.models.static_location_actions_post201_response import StaticLocationActionsPost201Response
from openapi_client.models.static_location_actions_static_location_action_id_patch_request import StaticLocationActionsStaticLocationActionIdPatchRequest
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost/rdm/svm-api/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "http://localhost/rdm/svm-api/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'

# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.StaticLocationActionsApi(api_client)
    static_location_action_id = 'static_location_action_id_example' # str | 
    static_location_actions_static_location_action_id_patch_request = openapi_client.StaticLocationActionsStaticLocationActionIdPatchRequest() # StaticLocationActionsStaticLocationActionIdPatchRequest | Static location attributes

    try:
        api_response = api_instance.static_location_actions_static_location_action_id_patch(static_location_action_id, static_location_actions_static_location_action_id_patch_request)
        print("The response of StaticLocationActionsApi->static_location_actions_static_location_action_id_patch:\n")
        pprint(api_response)
    except Exception as e:
        print("Exception when calling StaticLocationActionsApi->static_location_actions_static_location_action_id_patch: %s\n" % e)
```



### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **static_location_action_id** | **str**|  | 
 **static_location_actions_static_location_action_id_patch_request** | [**StaticLocationActionsStaticLocationActionIdPatchRequest**](StaticLocationActionsStaticLocationActionIdPatchRequest.md)| Static location attributes | 

### Return type

[**StaticLocationActionsPost201Response**](StaticLocationActionsPost201Response.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/vnd.api+json
 - **Accept**: application/vnd.api+json

### HTTP response details

| Status code | Description | Response headers |
|-------------|-------------|------------------|
**201** | Payload of the updated static location |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

