# coding: utf-8

"""
    Sensor Management System SMS

    REST API for managing sensor metadata. This API is based on {json:api} specification see: https://jsonapi.org/

    The version of the OpenAPI document: develop
    Contact: gitlab-incoming+hub-terra-sms-orchestration-3268-issue-@hzdr.de
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class UpdateDatastreamLinkObjectRequestDataAttributes(BaseModel):
    """
    UpdateDatastreamLinkObjectRequestDataAttributes
    """ # noqa: E501
    begin_date: Optional[datetime] = None
    end_date: Optional[datetime] = None
    datasource_id: Optional[StrictStr] = None
    datasource_name: Optional[StrictStr] = None
    thing_id: Optional[StrictStr] = None
    thing_name: Optional[StrictStr] = None
    datastream_id: Optional[StrictStr] = None
    datastream_name: Optional[StrictStr] = None
    license_uri: Optional[StrictStr] = None
    license_name: Optional[StrictStr] = None
    aggregation_period: Optional[Union[StrictFloat, StrictInt]] = None
    __properties: ClassVar[List[str]] = ["begin_date", "end_date", "datasource_id", "datasource_name", "thing_id", "thing_name", "datastream_id", "datastream_name", "license_uri", "license_name", "aggregation_period"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateDatastreamLinkObjectRequestDataAttributes from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateDatastreamLinkObjectRequestDataAttributes from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "begin_date": obj.get("begin_date"),
            "end_date": obj.get("end_date"),
            "datasource_id": obj.get("datasource_id"),
            "datasource_name": obj.get("datasource_name"),
            "thing_id": obj.get("thing_id"),
            "thing_name": obj.get("thing_name"),
            "datastream_id": obj.get("datastream_id"),
            "datastream_name": obj.get("datastream_name"),
            "license_uri": obj.get("license_uri"),
            "license_name": obj.get("license_name"),
            "aggregation_period": obj.get("aggregation_period")
        })
        return _obj


