# SPDX-FileCopyrightText: 2022
# - Nils Brinckmann <nils.brinckmann@gfz-potsdam.de>
# - Helmholtz Centre Potsdam - GFZ German Research Centre for Geosciences (GFZ, https://www.gfz-potsdam.de)
#
# SPDX-License-Identifier: EUPL-1.2

# Generated by Django 4.0.1 on 2022-03-03 06:34

import django.db.models.deletion
from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ("app", "0010_auto_20220111_0830"),
    ]

    operations = [
        migrations.AlterModelOptions(
            name="contactroles",
            options={
                "ordering": ["term"],
                "verbose_name": "Contact role",
                "verbose_name_plural": "Contact roles",
            },
        ),
        migrations.AlterField(
            model_name="actioncategory",
            name="global_provenance",
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="%(class)ss",
                to="app.globalprovenance",
            ),
        ),
        migrations.AlterField(
            model_name="actiontype",
            name="global_provenance",
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="%(class)ss",
                to="app.globalprovenance",
            ),
        ),
        migrations.AlterField(
            model_name="aggregationtype",
            name="global_provenance",
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="%(class)ss",
                to="app.globalprovenance",
            ),
        ),
        migrations.AlterField(
            model_name="community",
            name="global_provenance",
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="%(class)ss",
                to="app.globalprovenance",
            ),
        ),
        migrations.AlterField(
            model_name="compartment",
            name="global_provenance",
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="%(class)ss",
                to="app.globalprovenance",
            ),
        ),
        migrations.AlterField(
            model_name="contactroles",
            name="global_provenance",
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="%(class)ss",
                to="app.globalprovenance",
            ),
        ),
        migrations.AlterField(
            model_name="contactrolescommunity",
            name="root",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.DO_NOTHING,
                related_name="contact_roles_communities",
                to="app.contactroles",
            ),
        ),
        migrations.AlterField(
            model_name="equipmentstatus",
            name="global_provenance",
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="%(class)ss",
                to="app.globalprovenance",
            ),
        ),
        migrations.AlterField(
            model_name="equipmenttype",
            name="global_provenance",
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="%(class)ss",
                to="app.globalprovenance",
            ),
        ),
        migrations.AlterField(
            model_name="manufacturer",
            name="global_provenance",
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="%(class)ss",
                to="app.globalprovenance",
            ),
        ),
        migrations.AlterField(
            model_name="measuredquantity",
            name="global_provenance",
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="%(class)ss",
                to="app.globalprovenance",
            ),
        ),
        migrations.AlterField(
            model_name="platformtype",
            name="global_provenance",
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="%(class)ss",
                to="app.globalprovenance",
            ),
        ),
        migrations.AlterField(
            model_name="samplingmedium",
            name="global_provenance",
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="%(class)ss",
                to="app.globalprovenance",
            ),
        ),
        migrations.AlterField(
            model_name="softwaretype",
            name="global_provenance",
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="%(class)ss",
                to="app.globalprovenance",
            ),
        ),
        migrations.AlterField(
            model_name="unit",
            name="global_provenance",
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="%(class)ss",
                to="app.globalprovenance",
            ),
        ),
    ]
